﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TPCWare.CDays14.Twitter.Service.Model
{
    public class AccessToken
    {
        public string OauthToken { get; set; }
        public string OauthTokenSecret { get; set; }
        public string UserId { get; set; }
        public string ScreenName { get; set; }

        public AccessToken(string body)
        {
            var items = new Dictionary<string, string>();
            foreach (var element in body.Split('&'))
            {
                string[] parts = element.Split('=');
                items.Add(parts[0], parts[1]);
            }
            if (items != null)
            {
                if (items.ContainsKey("oauth_token"))
                {
                    OauthToken = items["oauth_token"];
                }
                if (items.ContainsKey("oauth_token_secret"))
                {
                    OauthTokenSecret = items["oauth_token_secret"];
                }
                if (items.ContainsKey("user_id"))
                {
                    UserId = items["user_id"];
                }
                if (items.ContainsKey("screen_name"))
                {
                    ScreenName = items["screen_name"];
                }
            }
        }
    }
}
