﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TPCWare.CDays14.Twitter.Service.Model
{
    public static class OAuthAuthorizationHeader
    {
        public static string Value(Dictionary<string, string> requestParameters)
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("OAuth ");

            bool firstItem = true;
            foreach (var item in requestParameters)
            {
                if (firstItem)
                {
                    firstItem = false;
                }
                else
                {
                    sb.Append(", ");
                }
                sb.Append(Utils.PercentEncode(item.Key));
                sb.Append("=");
                sb.Append(Utils.DoubleQuoteChar);
                sb.Append(Utils.PercentEncode(item.Value));
                sb.Append(Utils.DoubleQuoteChar);
            }

            return sb.ToString();
        }
    }
}
