﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TPCWare.CDays14.Twitter.Service.Model
{
    public class RedirectToken
    {
        public string OauthToken { get; set; }
        public string OauthVerifier { get; set; }

        public RedirectToken(string absoluteUri)
        {
            string parametersData = absoluteUri.Split('?')[1];

            var parameters = new Dictionary<string, string>();

            foreach (var element in parametersData.Split('&'))
            {
                string[] parts = element.Split('=');
                parameters.Add(parts[0], parts[1]);
            }
            if (parameters != null)
            {
                if (parameters.ContainsKey("oauth_token"))
                {
                    OauthToken = parameters["oauth_token"];
                }
                if (parameters.ContainsKey("oauth_verifier"))
                {
                    OauthVerifier = parameters["oauth_verifier"];
                }
            }
        }
    }
}
