﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using TPCWare.CDays14.Twitter.Service.Model;

namespace TPCWare.CDays14.WP7
{
    public partial class MainPage : PhoneApplicationPage
    {
        // TwitterConsumerKey and TwitterConsumerSecret are test value
        // from 
        private string TwitterConsumerKey = "xvz1evFS4wEEPTGEFPHBog";
        private string TwitterConsumerSecret = "kAcSOqF21Fu85e7zjz7ZN2U4ZRhfV3WpwPAoE3Z7kBw";

        private string testPackedParameters = "include_entities=true&oauth_consumer_key=xvz1evFS4wEEPTGEFPHBog&oauth_nonce=kYjzVBB8Y0ZFabxSWbWovY3uYSQ2pTgmZeNu2VS4cg&oauth_signature_method=HMAC-SHA1&oauth_timestamp=1318622958&oauth_token=370773112-GmHxMAgYyLbNEtIKZeRNFsMKPR9EyMZeS9weJAEb&oauth_version=1.0&status=Hello%20Ladies%20%2B%20Gentlemen%2C%20a%20signed%20OAuth%20request%21";
        private string testSignatureBase = "POST&https%3A%2F%2Fapi.twitter.com%2F1%2Fstatuses%2Fupdate.json&include_entities%3Dtrue%26oauth_consumer_key%3Dxvz1evFS4wEEPTGEFPHBog%26oauth_nonce%3DkYjzVBB8Y0ZFabxSWbWovY3uYSQ2pTgmZeNu2VS4cg%26oauth_signature_method%3DHMAC-SHA1%26oauth_timestamp%3D1318622958%26oauth_token%3D370773112-GmHxMAgYyLbNEtIKZeRNFsMKPR9EyMZeS9weJAEb%26oauth_version%3D1.0%26status%3DHello%2520Ladies%2520%252B%2520Gentlemen%252C%2520a%2520signed%2520OAuth%2520request%2521";
        private string testSignatureKey = "kAcSOqF21Fu85e7zjz7ZN2U4ZRhfV3WpwPAoE3Z7kBw&LswwdoUaIvS8ltyTt5jkRh4J50vUPVVHtR2YPi5kE";
        private string testSignature = "tnnArxj06cWHq44gCs1OSKk/jLY=";

        private string requestSignature;

        // Constructor
        public MainPage()
        {
            InitializeComponent();
        }

        private void BtnGetSignature_Click(object sender, RoutedEventArgs e)
        {
            string oauthNonce = "kYjzVBB8Y0ZFabxSWbWovY3uYSQ2pTgmZeNu2VS4cg";
            string oauthTimestamp = "1318622958";

            string httpMethod = "POST";
            string baseUrl = "https://api.twitter.com/1/statuses/update.json";

            string oauthToken = "370773112-GmHxMAgYyLbNEtIKZeRNFsMKPR9EyMZeS9weJAEb";
            string oauthTokenSecret = "LswwdoUaIvS8ltyTt5jkRh4J50vUPVVHtR2YPi5kE";

            var optionalParameters = new Dictionary<string, string>()
            {
                { "status", "Hello Ladies + Gentlemen, a signed OAuth request!" },
                { "include_entities", "true" }
            };

            var signature = new Signature(httpMethod, baseUrl, oauthNonce, oauthTimestamp, TwitterConsumerKey, TwitterConsumerSecret, oauthToken, oauthTokenSecret, optionalParameters);

            requestSignature = signature.Compute();

            if (string.Equals(signature.PackedParameters, testPackedParameters))
            {
                PackedParameters.Text = "PackedParameters test passed.";
            }
            else
            {
                PackedParameters.Text = signature.PackedParameters;
                PackedParameters.Foreground = new SolidColorBrush(Colors.Red);
            }

            if (string.Equals(signature.SignatureBase, testSignatureBase))
            {
                SignatureBase.Text = "SignatureBase test passed.";
            }
            else
            {
                SignatureBase.Text = signature.SignatureBase;
                SignatureBase.Foreground = new SolidColorBrush(Colors.Red);
            }

            if (string.Equals(signature.SignatureKey, testSignatureKey))
            {
                SignatureKey.Text = "SignatureKey test passed.";
            }
            else
            {
                SignatureKey.Text = signature.SignatureBase;
                SignatureKey.Foreground = new SolidColorBrush(Colors.Red);
            }

            if (string.Equals(requestSignature, testSignature))
            {
                Signature.Text = string.Format("SignatureKey test passed: {0}", requestSignature);
            }
            else
            {
                SignatureKey.Text = requestSignature;
                SignatureKey.Foreground = new SolidColorBrush(Colors.Red);
            }

        }

        private void BtnGetHeader_Click(object sender, RoutedEventArgs e)
        {
            string testAuthorizationHeader = "OAuth oauth_consumer_key=\"xvz1evFS4wEEPTGEFPHBog\", oauth_nonce=\"kYjzVBB8Y0ZFabxSWbWovY3uYSQ2pTgmZeNu2VS4cg\", oauth_signature=\"tnnArxj06cWHq44gCs1OSKk%2FjLY%3D\", oauth_signature_method=\"HMAC-SHA1\", oauth_timestamp=\"1318622958\", oauth_token=\"370773112-GmHxMAgYyLbNEtIKZeRNFsMKPR9EyMZeS9weJAEb\", oauth_version=\"1.0\"";

            var requestParameters = new Dictionary<string, string>()
            {
                { "oauth_consumer_key", "xvz1evFS4wEEPTGEFPHBog" },
                { "oauth_nonce", "kYjzVBB8Y0ZFabxSWbWovY3uYSQ2pTgmZeNu2VS4cg" },
                { "oauth_signature", "tnnArxj06cWHq44gCs1OSKk/jLY=" },
                { "oauth_signature_method", "HMAC-SHA1" },
                { "oauth_timestamp", "1318622958" },
                { "oauth_token", "370773112-GmHxMAgYyLbNEtIKZeRNFsMKPR9EyMZeS9weJAEb" },
                { "oauth_version", "1.0" }
            };

            string oauthHeader = OAuthAuthorizationHeader.Value(requestParameters);

            if (string.Equals(oauthHeader, testAuthorizationHeader))
            {
                AuthorizationHeader.Text = "AuthorizationHeader test passed.";
            }
            else
            {
                AuthorizationHeader.Text = oauthHeader;
                AuthorizationHeader.Foreground = new SolidColorBrush(Colors.Red);
            }
        }

    }
}